include \masm32\MasmBasic\MasmBasic.inc	; [url=http://www.masm32.com/board/index.php?topic=12460]download[/url]
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

.data
align 16	; v1 needs it with SSE2
v1	dd 100
v2	dd 100
v3	dd 123
align 16	; v1r needs it with SSE2
v1r	REAL4 100.0
v2r	REAL4 100.0
v3r	REAL4 123.0

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	1000000	; one Mio would be a typical value
	REPEAT 2
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
				mov eax, 100
				mov ecx, 100
				mul ecx
			ENDM
			xchg eax, esi
		counter_end
		Print Str$("%i cycles for mul", eax), Str$("\tres=%i\n", esi)
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
				mov eax, 100
				imul eax, eax, 100
			ENDM
			xchg eax, esi
		counter_end
		Print Str$("%i cycles for imul", eax), Str$("\tres=%i\n", esi)
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
				fild v1
				fimul v2
				fistp v3
			ENDM
		counter_end
		Print Str$("%i cycles for fimul", eax), Str$("\tres=%i\n", v3)
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
				fld v1r
				fmul v2r
				fstp v3r
			ENDM
		counter_end
		Print Str$("%i cycles for fmul", eax), Str$("\tres=%i\n", v3r)
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
				mov eax, 100
				movd xmm0, eax
				mov ecx, 100
				movd xmm1, ecx
				pmuludq xmm1, xmm0
			ENDM
		counter_end
		Print Str$("%i cycles for pmuludq+movd", eax), Str$("\tres=%i\n", xmm1)
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
				movd xmm1, v2
				pmuludq xmm1, v1	; must be 16-byte aligned!!!
			ENDM
		counter_end
		Print Str$("%i cycles for pmuludq+mem4", eax), Str$("\tres=%i\n", xmm1)
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
				movss xmm1, v2r
				mulps xmm1, v1r	; must be 16-byte aligned!!!
			ENDM
		counter_end
		movss v3r, xmm1
		Print Str$("%i cycles for movss+mulps", eax), Str$("\tres=%i\n", v3r)
		Print
	ENDM

	Inkey CrLf$, "--- ok ---", Cr$
	Exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]